%define PACKAGE_NAME junkbuster
%define PACKAGE_URL http://www.waldherr.org/junkbuster/
%define JAIL /home/junkbuster
%define USERNAME ijb

Summary: The Internet Junkbuster v2.0.2
Vendor: http://www.waldherr.org/
Name: %PACKAGE_NAME
Version: 2.0.2
Release: 6kas2
Source0: http://internet.junkbuster.com/ijb20.tar.Z
Source1: http://www.waldherr.org/junkbuster/misc-junkbuster-stuff.tar.gz
Patch0: junkbuster-chroot.patch
Patch1: junkbuster-connect.patch
Copyright: GPL
BuildRoot: /tmp/junkbuster
Group: Networking/Utilities
URL: %PACKAGE_URL
Packager: Stefan Waldherr <stefan@waldherr.org>
Distribution: 5.x
Obsoletes: junkbuster-raw junkbuster-blank
Prereq: chkconfig

%changelog
* Thu Apr 27 2000 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
	Modified the chroot patch to print the reason of the failed system
	call (using strerror()), as suggested by Omer Shenker
	oshenker@iname.com.

* Tue Apr 25 2000 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
	Chroot patch. Connection logging patch.

* Sun Sep 12 1999 Stefan Waldherr <stefan@waldherr.org>
       Jan Willamowius (jan@janhh.shnet.org) fixed a bug in the 
       code which prevented the JB from handling URLs of the form
       user:password@www.foo.com. Fixed.

* Mon Aug  2 1999 Stefan Waldherr <stefan@waldherr.org>
	Blank images are no longer cached, thanks to a hint from Markus 
        Breitenbach <breitenb@rbg.informatik.tu-darmstadt.de>. The user 
        agent is NO longer set by the Junkbuster. Sadly, many sites depend 
        on the correct browser version nowadays. Incorporated many 
	suggestions from Jan "Yenya" Kasprzak <kas@fi.muni.cz> for the
        spec file. Fixed logging problem and since runlevel 2 does not 
        use networking, I replaced /etc/rc.d/rc2.d/S84junkbuster with
        /etc/rc.d/rc2.d/K09junkbuster thanks to Shaw Walker 
        <walker@netgate.net>. You should now be able to build this RPM as 
        a non-root user (mathias@weidner.sem.lipsia.de).

* Sun Jan 31 1999 Stefan Waldherr <stefan@waldherr.org>
	/var/log/junkbuster set to nobody. Added /etc/junkbuster/imagelist
	to allow more sophisticated matching of blocked images. Logrotate
	logfile. Added files for auto-updating the blocklist et al.

* Wed Dec 16 1998 Stefan Waldherr <stefan@waldherr.org>
	Configure blank version via config file. No separate blank
	version anymore. Added Roland's <roland@spinnaker.rhein.de>
	patch to show a logo instead of a blank area. Added a suggestion
	from Alex <alex@cocoa.demon.co.uk>: /var/lock/subsys/junkbuster.
	More regexps in the blocklist. Prepared the forwardfile for
	squid. Extended image regexp with help from gabriel 
	<somlo@CS.ColoState.EDU>.

* Thu Nov 19 1998 Stefan Waldherr <stefan@waldherr.org>
	All RPMs now identify themselves in the show-proxy-args page.
	Released Windoze version. Run junkbuster as nobody instead of
	root. 

* Fri Oct 30 1998 Stefan Waldherr <stefan@waldherr.org>
	Newest version. First release (hence the little version number
	mixture -- 2.0.2-0 instead of 2.0-7). This version tightens 
	security over 2.0.1; some multi-user sites will need to change 
	the listen-address in the configuration file. The blank version of
        the Internet Junkbuster has a more sophisticated way of replacing
	images. All RPMs identify themselves in the show-proxy-args page.

* Thu Sep 23 1998 Stefan Waldherr <stefan@waldherr.org>
	Modified the blocking feature, so that only GIFs and JPEGs are
	blocked and replaced but not HTML pages. Thanks to 
	"Gerd Flender" <plgerd@informatik.uni-siegen.de> for this nice
	idea. Added numerous stuff to the blocklist. Keep patches in
        seperate files and no longer in diffs (easier to maintain).

* Tue Jun 16 1998 Stefan Waldherr <swa@cs.cmu.edu>
        Moved config files to /etc/junkbuster directory, moved man page,
	added BuildRoot directive (Thanks to Alexey Nogin <ayn2@cornell.edu>)
        Made new version junkbuster-raw (which is only a stripped version of 
        the junkuster rpm, i.e. without my blocklist, etc.)

* Tue Jun 16 1998 (2.0-1)
	Uhm, not that much. Just a new junkbuster version that
	fixes a couple of bugs ... and of course a bigger 
	blocklist with the unique Now-less-ads-than-ever(SM)
	feature.
	Oh, one thing: I changed the default user agent to Linux -- no 
	need anymore to support Apple.

* Tue Jun 16 1998 (2.0-0)
	Now-less-ads-than-ever (SM)
	compiled with gcc instead of cc
	compiled with -O3, thus it should be a little faster
	show-proxy-args now works
	/etc/junkbuster.init wasn't necessary

* Tue Jun 16 1998 (1.4)
	some more config files were put into /etc
	The junkbuster-blank rpm returns a 1x1 pixel image, that gets 
	displayed by Netscape instead of the blocked image.
	Read http://www.waldherr.org/junkbuster/ for
	further info.

* Tue Jun 16 1998 (1.3)
	The program has been moved to /usr/sbin (from /usr/local/bin)
	Init- and stopscripts (/etc/rc.d/rc*) have been added so
	that the junkbuster starts automatically during bootup.
	The /etc/blocklist file is much more sophisticated. Theoretically
	one should e.g. browse all major US and German newspapers without
	seeing one annoying ad.
	junkbuster.init was modified. It now starts junkbuster with an
	additional "-r @" flag.

Conflicts: junkbuster-raw junkbuster

%description
The Internet Junkbuster (TM) blocks unwanted banner ads and protects
your privacy from cookies and other threats. It's free under the GPL
(no warranty), runs under *NIX and works with almost any browser. You
need to clear you browser's cache and specify the proxy-server,
described in /usr/doc/junkbuster.  This is a modified version which
returns a blank GIF for blocked images by default.  But you can
configure this via /etc/junkbuster/config.

#
# -----------------------------------------------------------------------------
#

%prep

#
# -----------------------------------------------------------------------------
#

# also `-a 1' unpack the misc-junkbuster-stuff archive
%setup -n ijb20 -a 1

cp -rf swa/* .
#cp -f swa/Makefile .
#cp -f swa/jcc.c .
#cp -f swa/jcc.h .
#cp -f swa/loaders.c .
#cp -f swa/filters.c .
#cp -f swa/manfile.patch .
#cp -f swa/blocklist .
#cp -f swa/imagelist .
#cp -f swa/cookiefile .
#cp -f swa/config .
#cp -f swa/forward .
#cp -f swa/README.TOO .
#cp -f swa/squid.txt .
#cp -f swa/junkbstr.ini .
#cp -f swa/junkbuster.weekly .
#cp -f swa/junkbuster.monthly .
#cp -f swa/junkbuster.logrotate .
patch < manfile.patch

%patch0 -p1 -b .chroot
%patch1 -p1 -b .connect
#
# -----------------------------------------------------------------------------
#

%build

export DISTNAME='\"%PACKAGE_NAME-%PACKAGE_VERSION-%PACKAGE_RELEASE\"'
export DISTURL='\"%PACKAGE_URL\"'
make MORE_CFLAGS="$RPM_OPT_FLAGS"' -D_DISTNAME="$(DISTNAME)" -D_DISTURL="$(DISTURL)"'
make
strip junkbuster

#
# -----------------------------------------------------------------------------
#

%pre
if [ -f /etc/rc.d/init.d/junkbuster.init ]; then
        /etc/rc.d/init.d/junkbuster.init stop
fi
if [ -f /etc/rc.d/init.d/junkbuster ]; then
        /etc/rc.d/init.d/junkbuster stop
fi

if /usr/sbin/useradd -c 'Internet JunkBuster' -d %JAIL \
        -M -r -n -s /bin/false %USERNAME 2>/dev/null
then
        echo "Added the %USERNAME user to the system files." >&2
fi
if test -d /etc/junkbuster
then
        mv /etc/junkbuster /etc/junkbuster.rpmorig
fi
if test -d /var/log/junkbuster
then
        mv /var/log/junkbuster /var/log/junkbuster.rpmorig
fi


#
# -----------------------------------------------------------------------------
#

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{var/log,usr/{sbin,man/man8},etc/{logrotate.d,cron.weekly,cron.monthly,rc.d/{init.d,rc{0,1,2,3,5,6}.d}}}
mkdir -p $RPM_BUILD_ROOT/%JAIL/{etc/junkbuster,lib,var/log/junkbuster}

sed 's#^user ijb$#user %{USERNAME}#
s#^rootdir /home/junkbuster$#rootdir %{JAIL}#' <config >config.new
install -s -m 744 junkbuster $RPM_BUILD_ROOT/usr/sbin/junkbuster
cp -f junkbuster.1 $RPM_BUILD_ROOT/usr/man/man8/junkbuster.8
cp -f blocklist $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/blocklist
cp -f imagelist $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/imagelist
cp -f cookiefile $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/cookiefile
cp -f saclfile.ini $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/aclfile
cp -f config.new $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/config
cp -f forward $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/forward
cp -f strust.ini $RPM_BUILD_ROOT/%JAIL/etc/junkbuster/trust
cp -f junkbuster.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/junkbuster
cp -f swa/README.TOO .
cp -f swa/squid.txt .

install -m 755 swa/junkbuster.init $RPM_BUILD_ROOT/etc/rc.d/init.d/junkbuster
install -m 744 -d $RPM_BUILD_ROOT/%JAIL/var/log/junkbuster

ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K09junkbuster
ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc1.d/K09junkbuster
ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc2.d/K09junkbuster
ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S84junkbuster
ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S84junkbuster
ln -sf ../init.d/junkbuster $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K09junkbuster

ln -sf ..%JAIL/etc/junkbuster $RPM_BUILD_ROOT/etc/junkbuster
ln -sf ../..%JAIL/var/log/junkbuster $RPM_BUILD_ROOT/var/log/junkbuster

cp /lib/libresolv.so.2 /lib/libnss_dns.so.2 $RPM_BUILD_ROOT/%JAIL/lib
touch $RPM_BUILD_ROOT/%JAIL/etc/resolv.conf

#
# -----------------------------------------------------------------------------
#

%preun
if [ -f /etc/rc.d/init.d/junkbuster.init ]; then
        /etc/rc.d/init.d/junkbuster.init stop
fi
if [ -f /etc/rc.d/init.d/junkbuster ]; then
        /etc/rc.d/init.d/junkbuster stop
fi

#
# -----------------------------------------------------------------------------
#

%post
cat << EOT >&2

Now you'll need to start junkbuster with 

	/etc/rc.d/init.d/junkbuster start

or simply reboot; It will be started automatically at boot time. 
Don't forget to add the proxy stuff in Netscape.

EOT

# check configuration of start/stop/ scripts
# /sbin/chkconfig --add junkbuster

if [ -f %JAIL/etc/resolv.conf ]
then :
else
	/bin/cp /etc/resolv.conf %JAIL/etc/resolv.conf
fi


#
# -----------------------------------------------------------------------------
#

%clean
rm -rf $RPM_BUILD_ROOT

#
# -----------------------------------------------------------------------------
#

%files
%defattr(-,root,root)
%doc ijbfaq.html ijbman.html README README.TOO gpl.html 
%doc squid.txt junkbuster.weekly junkbuster.monthly README.chroot
%attr (0755,%USERNAME,root) %JAIL/var/log/junkbuster
%dir %JAIL
%config %JAIL/etc/junkbuster/*
%config /etc/logrotate.d/junkbuster
/etc/junkbuster
/var/log/junkbuster
%attr(0755,root,root) /usr/sbin/junkbuster
/usr/man/man8/junkbuster.8
%config /etc/rc.d/init.d/junkbuster
%config(missingok) /etc/rc.d/rc0.d/K09junkbuster
%config(missingok) /etc/rc.d/rc1.d/K09junkbuster
%config(missingok) /etc/rc.d/rc2.d/K09junkbuster
%config(missingok) /etc/rc.d/rc3.d/S84junkbuster
%config(missingok) /etc/rc.d/rc5.d/S84junkbuster
%config(missingok) /etc/rc.d/rc6.d/K09junkbuster
%JAIL/lib
